#include <mglaugust2.h>
#include <roast/roast.hpp>
#include <vector>
#include <string>

#undef GetClassName		//	Ɍ떂EEEib

#define PARENT_STR		".."
#define ITEM_INTERVAL	(17)
#define TITLE			"Neptune Explorer - v0.000000001(1)"

using namespace std;

//////////////////////////////////////////////////////

//	t@CEfBNg1ځiCAugustText2pj
class CFileItem : public CAugustText2
{
public:
	static const char* CLASS_NAME;
protected:
	roast::CFile m_file;

	CAugust2dSquare2 m_bg;		//	}EXJ[\킹ɔȂA
	CAugustImage2 m_imgIcon;	//	ACR

_AGH_EVENT_ACCESS_MODIFIER:
	virtual void OnRegist()
	{
		CAugustText2::OnRegist();

		RegistControl(&m_bg);
		RegistControl(&m_imgIcon);
	}

	//	lp̃tF[hAEg
	virtual bool OnFrame(){
		int al = m_bg.GetAlpha() - 8;
		if ( al < 0 )
			al = 0;
		m_bg.SetAlpha(al);

		return true;
	}

public:
	CFileItem(){
		SetClassName(CLASS_NAME);
	}
	
	void SetFile(roast::CFile &file)
	{
		m_file = file;

		SetText(m_file.GetFullPath());

		//	ACRݒ
		if ( m_file.IsFile() )
			m_imgIcon.Load("file.bmp");
		else
			m_imgIcon.Load("folder.bmp");
		m_imgIcon.SetPos(-16,-2);

		//	̑ꏊƂFƂ
		m_bg.SetRect(0,0,400,15);
		m_bg.SetColor(0);

		this->SetRect(0,0,400,15);
		this->SetColor(0x80000000);
	}

	void OverCursor()
	{
		m_bg.SetColor(AGHCOLOR_XRGB(200,200,200));
	}
};
const char* CFileItem::CLASS_NAME = "sf/jp/neptune/CFileItem";


//////////////////////////////////////////////////////

//	Ct[NX
class CMyFrame : public CAugustWindowFrame2
{
private:
	CAugustMouseInput m_mouse;		//	}EX͊Ǘ
	CAugustText2 m_txtTitle;		//	t@CpXs
	CAugustText2 m_frameRateTitle;	//	t[[g\
	agh::CControlArray<CFileItem> m_fileAry;	//	t@CQ

	//	t@C̒ǉ
	void AddFile(roast::CFile &file)
	{
		CFileItem& rItem = m_fileAry.Add();

		rItem.SetFile(file);
		rItem.SetPos(22, m_fileAry.size()*ITEM_INTERVAL);
	}

public:

	//	ɌĂ΂
	bool OnGraphicInitEnded()
	{
		//	Rg[NX̓o^
		RegistControl(&m_txtTitle);
		RegistControl(&m_frameRateTitle);
		RegistControl(&m_mouse);
		RegistControl(&m_fileAry);

		///////////////////////////////////////////

		//DirSel("C:\\");
		DriveList();

		//	}EXNbNnh̓o^
		m_mouse.RegistHandler(
			CAugustMouseInput::EVTTYPE_ON_DOWN,
			CAugustMouseInput::LBUTTON,
			(CAugustMouseInput::CALLBACK_TYPE_MI)&CMyFrame::OnMouseLDown,
			this);

		//	}EXړnh̓o^
		m_mouse.RegistHandler(
			CAugustMouseInput::EVTTYPE_ON_MOVE,
			0,
			(CAugustMouseInput::CALLBACK_TYPE_MI)&CMyFrame::OnMouseMove,
			this);

		//	}EXzC[nh̓o^
		m_mouse.RegistHandler(
			CAugustMouseInput::EVTTYPE_ON_MOVE,
			CAugustMouseInput::CBUTTON,
			(CAugustMouseInput::CALLBACK_TYPE_MI)&CMyFrame::OnMouseWheel,
			this);

		//	wiF
		this->SetColor(AGHCOLOR_XRGB(150,100,100));

		//	FPS\̏ꏊݒ
		m_frameRateTitle.SetPos(730,600-20);

		return true;
	}

	//////////////////////////////////////////////////////

	//	NbNɌĂ΂
	bool OnMouseLDown(int x, int y)
	{
		//	NbNӏ̃Rg[擾
		agh::CVisualControlBase *pCtrl = m_fileAry.HitTestRecursive(agh::CPoint(x,y));
		
		//	NULLȊONbNӏɃRg[L, NULLRg[Ȃ
		if ( pCtrl != NULL )
		{
			//	̃NXCFileItemł邩𔻒
			if ( strcmp( pCtrl->GetClassName(), CFileItem::CLASS_NAME ) == 0 )
			{
				CFileItem* pFileItem = (CFileItem*)pCtrl;

				std::string strText = pFileItem->GetText();	//	UʕϐɃRs[ĂȂƁAClear()ŃRg[łNGɂȂEEE
				
				//	u..v̏ꍇ
				if ( strText.compare(PARENT_STR) == 0 ){
					std::string parent = roast::CFile(m_txtTitle.GetText()).GetParent().GetFilePath();
					
					if ( *(parent.c_str()) == '\0' )
						DriveList();
					else
						DirSel( parent.c_str() );
				}
				
				//	u..vȊO
				else {
					if ( roast::CFile(strText).IsFile() ){
						//	t@C̎sibEEEj
						system(strText.c_str());
					}
					else {
						//	fBNgI
						DirSel(strText.c_str());
					}
				}
			}
		}
		return true;
	}

	//	}EXړɌĂ΂
	bool OnMouseMove(int x, int y)
	{
		//	݂̃}EXJ[\̃Rg[擾
		agh::CVisualControlBase *pCtrl = m_fileAry.HitTestRecursive(m_mouse.GetCursorPos());
		
		//	NULLȊOJ[\ʒuɃRg[L, NULLRg[Ȃ
		if ( pCtrl != NULL )
		{
			//	̃NXCFileItemł邩𔻒
			if ( strcmp( pCtrl->GetClassName(), CFileItem::CLASS_NAME ) == 0 )
			{
				CFileItem* pFileItem = (CFileItem*)pCtrl;

				pFileItem->OverCursor();
			}
		}
		return true;
	}

	//	}EXzC[ɌĂ΂
	bool OnMouseWheel(int x, int y)
	{
		//	ɍsȂ悤ɂ
		if ( x > 0 ){
			if ( m_fileAry.GetPos().y < 0 )
				m_fileAry.Move(0, ITEM_INTERVAL*3 );
		}
		else{
			m_fileAry.Move(0, -ITEM_INTERVAL*3 );
		}
		return true;
	}

	//	EChEOɌĂ΂
	void OnCreateWindow(agh::CREATE_WINDOW_INFO *pWindowInfo){
		pWindowInfo->nWinWidthSize = 800;
		pWindowInfo->nWinHeightSize = 600;
		pWindowInfo->strWindowTitle = TITLE;
	}

	////////////////////////////////////////////////

	//	hCuꗗ
	void DriveList()
	{
		m_fileAry.SetPos(0,0);
		m_fileAry.Clear();

		this->SetWindowTitle(TITLE);
		m_txtTitle.SetText("");

		std::vector<roast::CFile> fileList;
		roast::CFile::GetDriveList( fileList );

		for(size_t i=0; i<fileList.size(); i++)
		{
			AddFile(fileList[i]);
		}
	}

	//	fBNgI
	void DirSel(const char* szDir)
	{
		m_fileAry.SetPos(0,0);
		m_fileAry.Clear();

		this->SetWindowTitle(szDir);
		m_txtTitle.SetText(szDir);
		
		std::vector<roast::CFile> fileList;
		roast::CFile(szDir).GetChildList( fileList );

		//	u..vǉ
		AddFile(roast::CFile(PARENT_STR));

		for(size_t i=0; i<fileList.size(); i++)
		{
			AddFile(fileList[i]);
		}
	}

	virtual bool OnFrame(){
		//	t[[g\
		char work[256];
		sprintf(work, "%f", m_fps.GetAveFps());
		m_frameRateTitle.SetText(work);

		return true;
	}
};

//	WinMain
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	CMyFrame frame;
	frame.Start();
	return 0;
}
